summaryrefslogtreecommitdiffstats
path: root/meinsack
diff options
context:
space:
mode:
authorChinaman <root@chinaman>2011-09-06 19:47:58 +0200
committerChinaman <root@chinaman>2011-09-06 19:47:58 +0200
commit108f3616e3f4958752d881192ef29e5fc4c2b045 (patch)
tree3c67478c852265219b72e6e1b05467d7065b7ba8 /meinsack
parentb2d65500160bcdf7abb2bf985f7da582b810e25c (diff)
parentc3bc5a6d16868c121aca780f3109155797b51d76 (diff)
Merge branch 'master' of github.com:krebscode/painload
Diffstat (limited to 'meinsack')
-rwxr-xr-xmeinsack/index85
1 files changed, 85 insertions, 0 deletions
diff --git a/meinsack/index b/meinsack/index
new file mode 100755
index 00000000..7046d78c
--- /dev/null
+++ b/meinsack/index
@@ -0,0 +1,85 @@
+#! /bin/sh
+#
+# //meinsack
+#
+# export plz
+# export str
+# export anr
+# export ort
+#
+set -euf
+cd $(dirname $(readlink -f $0))/.. # cd //
+
+plz=${plz+"&plz=$plz"}
+str=${str+"&str=$str"}
+anr=${anr+"&anr=$anr"}
+
+url="http://www.sita-deutschland.de/sita/ywbase_Abfallkalender_Stuttgart.nsf/frmSelect?ReadForm$plz$str$anr"
+
+# echo $url
+
+html="$(curl -fsS "$url" | iconv -f latin1 -t utf8)"
+
+if echo "$html" | fgrep -q 'Ihre Eingabe war nicht eindeutig'; then
+ {
+ echo "Error: multiple locations found"
+ echo "$html" |
+ query/jquery/index 'table.tab:nth-child(2n) .bordertop > .text' |
+ sed '
+ s/[[:space:]]\+/ /g
+ s/'"`printf '\xc2\xa0'`"'//g;# kill unicode non-breaking space
+ ' |
+ while read plz &&
+ read str &&
+ read ort &&
+ read bes1 &&
+ read bes2 &&
+ read anr; do
+ str=$(echo "$str"|sed 's/<[^>]*>//g')
+ echo "export anr=$anr if you meant \"$ort\""
+ done | sort | uniq
+ } >&2
+ exit 2
+elif test $(echo "$html" | grep -c 'Abfallkalender für') -gt 1 &&
+ test -z "${ort-}"; then
+ {
+ echo "Error: multiple locations found"
+ echo "$html" |
+ query/jquery/index '.tab span.text,.subheadline' |
+ sed -n '
+ s/[[:space:]]\+/ /g
+ s/'"`printf '\xc2\xa0'`"'//g;# kill unicode non-breaking space
+ s/^Abfallkalender.*[^0-9]\([0-9]\+\)[^(]*(\(.*\))/export ort=\2/p
+ ' | sort | uniq
+ } >&2
+ exit 3
+else
+ result="$(echo "$html" |
+ query/jquery/index '.tab span.text,.subheadline' | {
+ if test -n "${ort-}"; then
+ sed -n "
+ /($ort)/,/^Abfallkalender/{p;b}
+ /($ort)/,\${p;b}
+ "
+ else
+ cat
+ fi
+ } | {
+ grep -v Abfallkalender |
+ sed '
+ s/'"`printf '\xc2\xa0'`"'//g;# kill unicode non-breaking space
+ s/^[A-Z][a-z]\.\([0-9]*\)\.\([0-9]*\)\.\([0-9]*\)$/\3-\2-\1/
+ s/^[0-9].*/ "&T00:00:00.000Z"/
+ $!s/$/,/
+ 1s/^/[\n/
+ $s/$/\n]/
+ '
+ })"
+ if ! echo "$result" | grep .; then
+ {
+ echo "Error: your query had no effect"
+ echo "url=\"$url\""
+ } >&2
+ exit 4
+ fi
+fi